{ pkgs ? import <nixpkgs> {}}:

let
  # create a modified haskell package set with my package inside it and broken dependencies
  # jailbroken.
  hpkgs = pkgs.haskellPackages.override {
    overrides = hself: hsuper: {
      matebeamter = hself.callCabal2nix "matebeamter" (gitignore ./.) {};
      mateamt = hself.callCabal2nix "mateamt" (gitignore ../mateamt) {};
      i18n = with pkgs.haskell.lib;
        doJailbreak (unmarkBroken (dontCheck hsuper.i18n));
      pg-transact = with pkgs.haskell.lib;
        doJailbreak (unmarkBroken (dontCheck hsuper.pg-transact));
      token-bucket = with pkgs.haskell.lib;
        doJailbreak (unmarkBroken (dontCheck hsuper.token-bucket));
    };
  };
  gitignore = dir: pkgs.nix-gitignore.gitignoreSource [] dir;
in
  hpkgs.matebeamter.env
